// Evalutor.cpp: implementation of the Evalutor class.
//
//////////////////////////////////////////////////////////////////////

#include <qmessagebox.h>
#include <stdio.h>
#include "Evalutor.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Evalutor::Evalutor()
{
	// set the error codes
	perl_errors[0] = "Zadna chyba";
	perl_errors[1] = "Potrebuji vice pameti k vraceni vysledku";
	perl_errors[2] = "Chyba Perlu:";
	perl_errors[3] = "Potrebuji vice pameti k vraceni chybove zpravy";
	perl_errors[4] = "Spatny formatovaci retezec";
	perl_errors[5] = "Volani funkce vyvolalo vyjimku";
	perl_errors[6] = "PerlHandle byla spatna";
	perl_errors[7] = "Druhe volani funkce PerlEzSetMagicFunction selhalo";
	perl_errors[8] = "Spatne parametry byly predany funkci";
	perl_errors[9] = "Malo pameti";

	perl = PerlEzCreate(NULL, NULL);
}

Evalutor::~Evalutor()
{
	PerlEzDelete(perl);
}

double Evalutor::TheFunction(double a, double b)
{
	DWORD result_size = 1000;
	char result[1000] = "";
	int err_code = 0;
	
	err_code = PerlEzCall2(perl, "function",  result, result_size, "dd", &a, &b);
	
	if (err_code != 0) {
		return 0.0f;
	} else {
		return atof(result);
	}
}

void Evalutor::SetFunction(const char* function)
{
	DWORD result_size = 1000;
	int err_code = 0;
	char message[1000] = "";
	char result[1000] = "";

	err_code = PerlEzEvalString(perl, function, result, result_size);
	if (err_code != 0) {
		strcpy(message, perl_errors[err_code]);
		strcat(message, result);
		QMessageBox::critical( NULL, "Chyba volani Perlu", message);
	}
}

void Evalutor::TestFunction()
{
	char result[1000] = "";
	sprintf(result, "Vysledek volani 'function(1,1)': %f", TheFunction(1.0, 1.0));
	QMessageBox::information( NULL, "Test", result);
}
