
#ifndef GLBOX_H
#define GLBOX_H

#include <qgl.h>
#include "evalutor.h"

class GLBox : public QGLWidget
{
    Q_OBJECT

public:

//    GLBox( QWidget* parent, const char* name );
    GLBox( QWidget* parent, const char* name, Evalutor* eval );
    ~GLBox();

public slots:
	void RebuildScene();

    void		setXRotation( int degrees );
    void		setYRotation( int degrees );
    void		setZRotation( int degrees );

    void		setXRotationFactor( int degrees );
    void		setYRotationFactor( int degrees );
    void		setZRotationFactor( int degrees );

    void		setZPosition( int x );

	void		timerMove();

protected:

    void		initializeGL();
    void		paintGL();
    void		resizeGL( int w, int h );

    virtual GLuint 	makeObject();

private:

    GLuint object;
    GLfloat xRot, yRot, zRot, scale;
    int xRotFact, yRotFact, zRotFact;
	float zPosition;
	Evalutor* eval;

	double domain_x_from, domain_y_from, domain_x_to, domain_y_to;
	double domain_x_step, domain_y_step;
};


#endif // GLBOX_H
